commit 6a2083295555b5d9774df6644b90b5dd744e15cf
Author: freddy77 <freddy77>
Date:   Tue Dec 15 11:23:46 2009 +0000

    Fix data_type returned from statistics function

diff --git a/ChangeLog b/ChangeLog
index a2020ac..3b54ad5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Tue Dec 15 12:23:27 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/unittests/Makefile.am:
+	* src/odbc/unittests/common.h src/odbc/unittests/stats.c:
+	- Fix data_type returned from statistics function
+
 Tue Dec 15 10:52:43 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsodbc.h src/odbc/connectparams.c src/odbc/odbc.c:
 	- Avoid wrong configuration problem reporting problems
@@ -1986,4 +1991,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2906 2009/12/15 09:53:26 freddy77 Exp $
+$Id: ChangeLog,v 1.2907 2009/12/15 11:23:46 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 9edba50..de28180 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.518 2009/12/15 09:53:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.519 2009/12/15 11:23:47 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -916,9 +916,10 @@ SQLProcedureColumns(SQLHSTMT hstmt, SQLCHAR FAR * szCatalogName, SQLSMALLINT cbC
 			hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szProcName, cbProcName, szColumnName, cbColumnName);
 
 	retcode =
-		odbc_stat_execute(stmt, "sp_sproc_columns ", 4, "O@procedure_qualifier", szCatalogName, cbCatalogName,
+		odbc_stat_execute(stmt, "sp_sproc_columns ", TDS_IS_MSSQL(stmt->dbc->tds_socket) ? 5 : 4,
+				  "O@procedure_qualifier", szCatalogName, cbCatalogName,
 				  "P@procedure_owner", szSchemaName, cbSchemaName, "P@procedure_name", szProcName, cbProcName,
-				  "P@column_name", szColumnName, cbColumnName);
+				  "P@column_name", szColumnName, cbColumnName, "V@ODBCVer", (char*) NULL, 0);
 	if (SQL_SUCCEEDED(retcode) && stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3) {
 		odbc_col_setname(stmt, 1, "PROCEDURE_CAT");
 		odbc_col_setname(stmt, 2, "PROCEDURE_SCHEM");
@@ -4531,9 +4532,10 @@ SQLColumns(SQLHSTMT hstmt, SQLCHAR FAR * szCatalogName,	/* object_qualifier */
 			hstmt, szCatalogName, cbCatalogName, szSchemaName, cbSchemaName, szTableName, cbTableName, szColumnName, cbColumnName);
 
 	retcode =
-		odbc_stat_execute(stmt, "sp_columns ", 4, "P@table_name", szTableName, cbTableName, "P@table_owner", szSchemaName,
+		odbc_stat_execute(stmt, "sp_columns ", TDS_IS_MSSQL(stmt->dbc->tds_socket) ? 5 : 4,
+				  "P@table_name", szTableName, cbTableName, "P@table_owner", szSchemaName,
 				  cbSchemaName, "O@table_qualifier", szCatalogName, cbCatalogName, "P@column_name", szColumnName,
-				  cbColumnName);
+				  cbColumnName, "V@ODBCVer", (char*) NULL, 0);
 	if (SQL_SUCCEEDED(retcode) && stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3) {
 		odbc_col_setname(stmt, 1, "TABLE_CAT");
 		odbc_col_setname(stmt, 2, "TABLE_SCHEM");
@@ -6384,9 +6386,10 @@ SQLSpecialColumns(SQLHSTMT hstmt, SQLUSMALLINT fColType, SQLCHAR FAR * szCatalog
 		col_type = 'V';
 
 	retcode =
-		odbc_stat_execute(stmt, "sp_special_columns ", TDS_IS_MSSQL(stmt->dbc->tds_socket) ? 6 : 4, "O", szTableName,
+		odbc_stat_execute(stmt, "sp_special_columns ", TDS_IS_MSSQL(stmt->dbc->tds_socket) ? 7 : 4, "O", szTableName,
 				  cbTableName, "O", szSchemaName, cbSchemaName, "O@qualifier", szCatalogName, cbCatalogName,
-				  "@col_type", &col_type, 1, "@scope", &scope, 1, "@nullable", &nullable, 1);
+				  "@col_type", &col_type, 1, "@scope", &scope, 1, "@nullable", &nullable, 1,
+				  "V@ODBCVer", (char*) NULL, 0);
 	if (SQL_SUCCEEDED(retcode) && stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3) {
 		odbc_col_setname(stmt, 5, "COLUMN_SIZE");
 		odbc_col_setname(stmt, 6, "BUFFER_LENGTH");
@@ -6781,6 +6784,8 @@ odbc_stat_execute(TDS_STMT * stmt, const char *begin, int nparams, ...)
 		p = va_arg(marker, char *);
 
 		switch (*p) {
+		case 'V':	/* ODBC version */
+			len += strlen(p) + 3;
 		case 'O':	/* ordinary arguments */
 		case 'P':	/* pattern value arguments */
 			params[i].type = *p++;
@@ -6821,14 +6826,17 @@ odbc_stat_execute(TDS_STMT * stmt, const char *begin, int nparams, ...)
 	strcpy(p, begin);
 	p += strlen(begin);
 	for (i = 0; i < nparams; ++i) {
-		if (!params[i].value)
+		if (!params[i].value && params[i].type != 'V')
 			continue;
 		if (params[i].name[0]) {
 			strcpy(p, params[i].name);
 			p += strlen(params[i].name);
 			*p++ = '=';
 		}
-		p += odbc_quote_metadata(stmt->dbc, params[i].type, p, params[i].value, params[i].len);
+		if (params[i].type != 'V')
+			p += odbc_quote_metadata(stmt->dbc, params[i].type, p, params[i].value, params[i].len);
+		else
+			*p++ = (stmt->dbc->env->attr.odbc_version == SQL_OV_ODBC3) ? '3': '2';
 		*p++ = ',';
 	}
 	*--p = '\0';
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index 6df8c3f..5edf080 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.80 2009/02/11 14:40:15 freddy77 Exp $
+# $Id: Makefile.am,v 1.81 2009/12/15 11:23:47 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -22,7 +22,8 @@ TESTS		=	\
 			cursor3$(EXEEXT) cursor4$(EXEEXT) cursor5$(EXEEXT) \
 			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT) \
 			cancel$(EXEEXT) wchar$(EXEEXT) rowset$(EXEEXT) transaction2$(EXEEXT) \
-			cursor6$(EXEEXT) cursor7$(EXEEXT) utf8$(EXEEXT) utf8_2$(EXEEXT)
+			cursor6$(EXEEXT) cursor7$(EXEEXT) utf8$(EXEEXT) utf8_2$(EXEEXT) \
+			stats$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -89,6 +90,7 @@ cursor6_SOURCES	= cursor6.c common.c common.h
 cursor7_SOURCES	= cursor7.c common.c common.h
 utf8_SOURCES	= utf8.c common.c common.h
 utf8_2_SOURCES	= utf8_2.c common.c common.h
+stats_SOURCES	= stats.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC) -DFREETDS_SRCDIR=\"$(srcdir)\"
 if MINGW32
diff --git a/src/odbc/unittests/common.h b/src/odbc/unittests/common.h
index 35ed75c..cbf0104 100644
--- a/src/odbc/unittests/common.h
+++ b/src/odbc/unittests/common.h
@@ -21,7 +21,7 @@
 #include <sql.h>
 #include <sqlext.h>
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.28 2008/12/03 12:55:52 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.29 2009/12/15 11:23:47 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #ifndef HAVE_SQLLEN
@@ -140,6 +140,10 @@ SQLSMALLINT AllocHandleErrType(SQLSMALLINT type);
 	CHKR2(SQLSetStmtOption, (Statement,a,b), SQL_HANDLE_STMT, Statement, res)
 #define CHKTables(a,b,c,d,e,f,g,h,res) \
 	CHKR2(SQLTables, (Statement,a,b,c,d,e,f,g,h), SQL_HANDLE_STMT, Statement, res)
+#define CHKProcedureColumns(a,b,c,d,e,f,g,h,res) \
+	CHKR2(SQLProcedureColumns, (Statement,a,b,c,d,e,f,g,h), SQL_HANDLE_STMT, Statement, res)
+#define CHKColumns(a,b,c,d,e,f,g,h,res) \
+	CHKR2(SQLColumns, (Statement,a,b,c,d,e,f,g,h), SQL_HANDLE_STMT, Statement, res)
 
 int Connect(void);
 int Disconnect(void);
diff --git a/src/odbc/unittests/stats.c b/src/odbc/unittests/stats.c
new file mode 100644
index 0000000..0b66617
--- /dev/null
+++ b/src/odbc/unittests/stats.c
@@ -0,0 +1,110 @@
+#include "common.h"
+
+static char software_version[] = "$Id: stats.c,v 1.1 2009/12/15 11:23:47 freddy77 Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+static SQLLEN cnamesize;
+static char output[256];
+
+static void
+ReadCol(int i)
+{
+	memset(output, 'x', sizeof(output));
+	strcpy(output, "NULL");
+	CHKGetData(i, SQL_C_CHAR, output, sizeof(output), &cnamesize, "S");
+}
+
+static const char *catalog = NULL;
+static const char *schema = NULL;
+static const char *proc = "stat_proc";
+static const char *table = "stat_proc";
+static const char *column = "@t";
+
+#define LEN(x) (x) ? strlen(x) : SQL_NULL_DATA
+
+static void
+TestProc(const char *type, const char *expected)
+{
+	char sql[256];
+
+	Command("IF OBJECT_ID('stat_proc') IS NOT NULL DROP PROC stat_proc");
+
+	sprintf(sql, "CREATE PROC stat_proc(@t %s) AS RETURN 0", type);
+	Command(sql);
+
+	column = "@t";
+	CHKProcedureColumns((SQLCHAR *) catalog, LEN(catalog), (SQLCHAR *) schema, LEN(schema), (SQLCHAR *) proc, LEN(proc), (SQLCHAR *) column, LEN(column), "SI");
+
+	CHKFetch("SI");
+
+	ReadCol(6);
+	if (strcmp(output, expected) != 0) {
+		fprintf(stderr, "Got \"%s\" expected \"%s\"\n", output, expected);
+		Disconnect();
+		exit(1);
+	}
+
+	CHKCloseCursor("SI");
+}
+
+static void
+TestTable(const char *type, const char *expected)
+{
+	char sql[256];
+
+	Command("IF OBJECT_ID('stat_t') IS NOT NULL DROP TABLE stat_t");
+
+	sprintf(sql, "CREATE TABLE stat_t(t %s)", type);
+	Command(sql);
+
+	column = "t";
+	table = "stat_t";
+	CHKColumns((SQLCHAR *) catalog, LEN(catalog), (SQLCHAR *) schema, LEN(schema), (SQLCHAR *) table, LEN(table), (SQLCHAR *) column, LEN(column), "SI");
+
+	CHKFetch("SI");
+
+	ReadCol(5);
+	if (strcmp(output, expected) != 0) {
+		fprintf(stderr, "Got \"%s\" expected \"%s\"\n", output, expected);
+		Disconnect();
+		exit(1);
+	}
+
+	CHKCloseCursor("SI");
+}
+
+
+#define STR(n) str(int_buf, n)
+
+static const char *
+str(char *buf, int n)
+{
+	sprintf(buf, "%d", n);
+	return buf;
+}
+
+int
+main(int argc, char *argv[])
+{
+	char int_buf[32];
+
+	use_odbc_version3 = 0;
+	Connect();
+
+	TestProc("DATETIME", STR(SQL_TIMESTAMP));
+	TestTable("DATETIME", STR(SQL_TIMESTAMP));
+
+	Disconnect();
+
+
+	use_odbc_version3 = 1;
+	Connect();
+
+	TestProc("DATETIME", STR(SQL_TYPE_TIMESTAMP));
+	TestTable("DATETIME", STR(SQL_TYPE_TIMESTAMP));
+
+	Disconnect();
+
+	printf("Done.\n");
+	return 0;
+}

